scode segment           ;jeden segment (kodu)
 org 100h               ;com od pocztku segmentu w pamici to psp + kod
 assume cs:scode
 start:
  jmp code

  ;rhytm - definicja rytmu
  ;x,,xx,x,
  ;,xx,x,,x
  ;x,,xx,x,
  ;xx,,x,xx
  ;x,,xx,x,
  ;,xx,x,,x
  ;x,,xx,x,
  ;xx,,x,xx

  ;melody - definicja melodii
  ;x,x,xxxx
  ;,xx,x,x,
  ;x,x,xxxx
  ;,xx,x,x,
  ;x,x,xxxx
  ;,xx,x,x,
  ;x,,x,,x,
  ;x,,x,,x,

  yn equ 04h    ;rhytm on, note off
  yy equ 10h    ;rhytm on, note on
  ny equ 0Ah    ;rhytm off, note on
  nn equ 01h    ;rhytm off, note off
  tr equ 0FFh   ;terminate
  floppy equ 0h ;numer stacji
  smask equ 16d ;scroll lock
  nmask equ 32d ;num lock
  cmask equ 64d ;caps lock
  keybyn equ nmask      ;maski klawiszy dla poszczeglnych stanw
  keybyy equ (nmask or cmask)
  keybny equ cmask
  keybnn equ 0h
  facecode equ 1h       ;kod ascii buki
  keyballoff equ (not (nmask or cmask or smask))   ;n/c/s off
  tintro db 0Dh, 0Ah
         db "                  ͻ", 0Dh, 0Ah
	 db "                              ", 0Dh, 0Ah
	 db "                      ͼ    ", 0Dh, 0Ah
	 db "                                  ", 0Dh, 0Ah
	 db "                                  ", 0Dh, 0Ah
	 db "                                  ", 0Dh, 0Ah
	 db "                                ", 0Dh, 0Ah
	 db "                  ͼ", 0Dh, 0Ah
	 db "DiskPlay - http://wysocki.lodz.pdi.net/~adam/diskplay/", 0Dh, 0Ah, '$'
  tplaying db "Now playing: Alphaville - Big in Japan. Floppy drive: 0.", 0Dh, 0Ah
	   db "'r' to toggle rhytm, 'm' to toggle melody and 'esc' to quit."
	   db 0Dh, 0Ah, '$'
  oldkeyb db 0h
  rhytm_ena db 1h
  melody_ena db 1h
  melody db yy, nn, ny, yn, yy, ny, yy, ny
	 db nn, yy, yy, nn, yy, nn, ny, yn
	 db yy, nn, ny, yn, yy, ny, yy, ny
	 db yn, yy, ny, nn, yy, nn, yy, yn
	 db yy, nn, ny, yn, yy, ny, yy, ny
	 db nn, yy, yy, nn, yy, nn, ny, yn
	 db yy, nn, nn, yy, yn, nn, yy, nn
	 db yy, yn, nn, ny, yn, nn, yy, yn
	 db tr
  melpos dw 0h          ;pozycja w tablicy melody
 code:
  push cs
  push cs
  pop ds
  pop es
  call setpal           ;catch i ustawienie palety
  lea dx, tintro
  mov ah, 09h
  int 21h
  call calibrate
  lea dx, tplaying
  mov ah, 09h
  int 21h
  call catchkeyb        ;zapamitanie stanu klawiatury
  mainloop:
   lea bx, melody
   add bx, melpos
   mov al, es:[bx]      ;teraz al zawiera aktualn nut
   cmp al, tr           ;jeli to ju koniec...
   je resetmelpos       ;...to od pocztku
   call proc_ena        ;funkcja przetwarzajca 'r' i 'm'
   push ax              ;setkeyb niszczy ax
   call setkeyb         ;ustawienie klawiatury
   pop ax
   call seekrel         ;przesunicie gowicy i narysowanie mordek
   inc melpos           ;nastpna nuta
   mov ah, 11h          ;nacinito klawisz?
   int 16h
   jnz handlekey
   jmp mainloop
  aftermainloop:
   call restorekeyb      ;przywrcenie stanu klawiatury
   call restorepal       ;przywrcenie palety
   int 20h               ;koniec
 resetmelpos:
  mov melpos, 0h
  jmp mainloop
 handlekey:
  mov ah, 10h
  int 16h               ;al - ascii
  cmp al, 27d           ;esc
  je aftermainloop
  cmp al, 'r'
  je togglerhytm
  cmp al, 'R'
  je togglerhytm
  cmp al, 'm'
  je togglemelody
  cmp al, 'M'
  je togglemelody
  jmp mainloop
 togglerhytm:
  xor rhytm_ena, 1h
  jmp mainloop
 togglemelody:
  xor melody_ena, 1h
  jmp mainloop

;proc_ena - przetworzenie stanu wczenia rytmu / melodii
;wejcie: al - stan wejciowy
;wyjcie: al - stan po przetworzeniu

proc_ena proc
 cmp rhytm_ena, 0h
 je proc_rhytm
 proc_ena_continue:
  cmp melody_ena, 0h
  je proc_melody
  ret
 proc_rhytm:
  cmp al, yy
  je proc_ena_rh_yy
  cmp al, yn
  je proc_ena_rh_yn
  jmp proc_ena_continue
 proc_melody:
  cmp al, ny
  je proc_ena_ml_ny
  cmp al, yy
  je proc_ena_ml_yy
  ret
 proc_ena_rh_yy:
  mov al, ny
  jmp proc_ena_continue
 proc_ena_rh_yn:
  mov al, nn
  jmp proc_ena_continue
 proc_ena_ml_ny:
  mov al, nn
  ret
 proc_ena_ml_yy:
  mov al, yn
  ret
proc_ena endp

;seek - przesunicie gowicy na okrelon pozycj
;wejcie: al - numer ciki od 0 do 79
;wyjcie: brak

seek proc
 call drawface
 sub dh, dh            ;head
 mov dl, floppy        ;drv
 mov ch, al            ;track
 mov cl, 1h            ;sect
 lea bx, sectbuf       ;es:buf
 mov ax, 0201h         ;func / numsect
 int 13h
 ret
seek endp

;seekrel - przesunicie gowicy o okrelon ilo cieek
;wejcie: al - odlego
;wyjcie: brak
;funkcja przesuwa gowic stacji w t stron, gdzie jeszcze
;zostao wicej cieek. korzysta z seek.

seekrel proc            ;al - distance
 jmp seekrelcode
  pos db 39d            ;aktualna cieka
 seekrelcode:
  cmp pos, 39d
  jg subtract           ;jeli jestemy za poow dyskietki to w d
  add pos, al           ;...a jeli nie to przesuwamy gowic w gr
  cmp pos, 79d
  jg equadd             ;jak przekroczylimy numer cieki to normalizacja
  jmp after
  subtract:
   sub pos, al
   cmp pos, 79d
   jg equsub            ;normalizacja dla liczb ze znakiem
   cmp pos, 0d
   jl equsub            ;normalizacja dla liczb bez znaku
  after:
   mov al, pos
   call seek            ;ustawienie gowicy
   ret
 equadd:
  mov pos, 79d
  jmp after
 equsub:
  mov pos, 0h
  jmp after
seekrel endp

;setkeyb - funkcja ustawia diody symbolizujce n/c/slock
;wejcie: ah - nuta
;wyjcie: brak

setkeyb proc
 jmp setkeybcode
  slock db 0h           ;stan scrollocka (zmienia si co nut)
 setkeybcode:
  mov bx, 40h
  mov ds, bx
  mov di, 17h
  mov ah, ds:[di]       ;ah - stan klawiatury
  and ah, keyballoff    ;wyzerowanie wszyskiego
  or ah, slock          ;ewentualne wczenie scrollocka
  xor slock, smask      ;0, smask, 0, smask, itp.
  cmp al, yy
  je yymask
  cmp al, yn
  je ynmask
  cmp al, ny
  je nymask
  or ah, keybnn
  setkeybafter:
   mov ds:[di], ah      ;ustawienie zmiennej
   ret                  ;i tyle! aktualizacja jak bdzie pobrany stan bufora
  yymask:
   or ah, keybyy
   jmp setkeybafter
  nymask:
   or ah, keybny
   jmp setkeybafter
  ynmask:
   or ah, keybyn
   jmp setkeybafter
setkeyb endp

;catchkeyb - funkcja zapisuje aktualny stan klawiatury
;wejcie: brak
;wyjcie: brak

catchkeyb proc
 mov bx, 40h
 mov ds, bx
 mov di, 17h
 mov al, ds:[di]
 mov oldkeyb, al
 ret
catchkeyb endp

;restorekeyb - przeciwiestwo catchkeyb. in/out jak wyej.

restorekeyb proc
 mov al, oldkeyb
 mov bx, 40h
 mov ds, bx
 mov di, 17h
 mov ds:[di], al
 mov ah, 11h
 int 16h
 ret
restorekeyb endp

;calibrate - funkcja ustawia gowic na rodku dyskietki.
;to daje moliwo synchronizacji zmiennej pos w seekrel
;z aktualnym stanem stacji.
;wejcie: brak
;wyjcie: brak

calibrate proc
 mov al, 39d
 call seek
 ret
calibrate endp

;drawface - wywietla mieszne, niebieskie mordki na dole ekranu :))
;wejcie: al - seekpos
;wyjcie: brak

drawface proc
 jmp drawfacecode
  facepostab db 6h dup (80d)            ;80d - niewidoczna mordka
 drawfacecode:
  push cs
  pop ds
  push ax
  lea di, facepostab
  mov al, 0h
  mov cl, 6h
  drawfaceloop:
   mov dl, ds:[di]
   cmp dl, 80d
   je afterdrawoneface
   call drawoneface
   afterdrawoneface:
    inc al
    inc di
    dec cl
    cmp cl, 0h
    jnz drawfaceloop
  pop ax
  lea di, facepostab
  call shiftfacetab
  ret
drawface endp

;drawoneface - rysuje jedn buk
;wejcie: dl - 'x', al - kolor
;wyjcie: brak

drawoneface proc
 push ds
 push di
 mov di, 0B800h         ;segment vram w trybie kolorowym
 mov ds, di             ;...do rejestru segmentowego
 mov di, 80 * 24 * 2    ;offset w pamici video
 sub dh, dh             ;wyzerowanie do sumowania (di jest 16-bitowy)
 shl dl, 1              ;nie bdzie > 128 -> dh jest nieistotny :p
 add di, dx             ;dopiero teraz jest
 mov ah, facecode       ;kod ascii buki
 xchg ah, al            ;eby byo atwiej zapisa
 mov ds:[di], ax        ;wpisanie caego sowa (ah - atrybut)
 xchg ah, al            ;przywracamy ax
 pop di
 pop ds
 ret
drawoneface endp

;shiftfacetab - przesuwa tablic buziek w lewo
;wejcie: ds:[di] - tablica, al - seekpos

shiftfacetab proc
 mov si, di
 inc si         ;es:[si] to teraz indeks ds:[di+1] (es = ds)
 mov cl, 5
 shiftonefaceloop:
  mov ah, es:[si]
  mov ds:[di], ah
  inc si
  inc di
  dec cl
  cmp cl, 0h
  jnz shiftonefaceloop
 mov ds:[di], al        ;nowa warto
 ret
shiftfacetab endp

;setpal - pobiera poprzedni palet i ustawia now
;wejcie: brak
;wyjcie: brak

setpal proc
 lea di, oldpal
 mov dx, 3C6h
 mov al, 0FFh
 out dx, al             ;ustawienie maski
 inc dx
 mov al, 0h             ;od rejestru #0
 out dx, al
 inc dx
 inc dx                 ;teraz dx to rejestr danych karty graficznej
 mov cl, 21d            ;liczba skadowych do pobrania
 setpalcatchloop:
  in al, dx
  mov ds:[di], al
  inc di
  dec cl
  cmp cl, 0h
  jnz setpalcatchloop
 dec dx
 mov al, 0h
 out dx, al             ;ustawienie pierwszego rejestru do zapisania
 inc dx                 ;znowu dx = rejestr danych
 mov cl, 7d             ;ile rejestrw do zapisania (kady po trzy skadowe)
 setpalsetloop:
  mov ah, al            ;zapamitanie al
  sub al, al            ;wyzerowanie
  out dx, al            ;wysanie po kolei wszystkich trzech skadowych
  out dx, al            ;(te dwie s rwne zeru)
  mov al, ah            ;z powrotem :)
  out dx, al            ;(ta jest zwikszana)
  add al, 8h            ;chyba optymalna warto
  dec cl
  cmp cl, 0h
  jnz setpalsetloop
 ret
setpal endp

;restorepal - ustawia poprzedni palet
;wejcie: brak
;wyjcie: brak

restorepal proc
 push cs
 pop ds
 lea di, oldpal
 mov dx, 3C6h
 mov al, 0FFh
 out dx, al             ;ustawienie maski
 inc dx
 inc dx
 mov al, 0h             ;od rejestru #0
 out dx, al
 inc dx                 ;teraz dx to rejestr danych karty graficznej
 mov cl, 21d            ;liczba skadowych do zapisania
 restorepalloop:
  mov al, ds:[di]
  out dx, al
  inc di
  dec cl
  cmp cl, 0h
  jnz restorepalloop
 ret
restorepal endp

oldpal db 21 dup (0h)
sectbuf db 512 dup (0h)

scode ends
end start
